---
pageClass: documentation-class
---

# Two.Ellipse


<div class="extends">

__Extends__: `Two.Path`

</div>





<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/ellipse.js#L11)

</div>



### Constructor


| Argument | Description |
| ---- | ----------- |
|  `x`  | The x position of the ellipse. |
|  `y`  | The y position of the ellipse. |
|  `rx`  | The radius value of the ellipse in the x direction. |
|  `ry`  | The radius value of the ellipse in the y direction. |
|  `resolution`  | The number of vertices used to construct the ellipse. |



---

<div class="static member ">

## Two.Ellipse.Properties








<div class="properties">

A list of properties that are on every [Two.Ellipse](/documentation/ellipse).

</div>








<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/ellipse.js#L60)

</div>






</div>



---

<div class="static function ">

## Two.Ellipse.MakeObservable










<div class="params">

| Argument | Description |
| ---- | ----------- |
|  `object`  | The object to make observable. |
</div>




<div class="description">

Convenience function to apply observable qualities of a [Two.Ellipse](/documentation/ellipse) to any object. Handy if you'd like to extend the [Two.Ellipse](/documentation/ellipse) class on a custom class.

</div>



<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/ellipse.js#L66)

</div>






</div>



---

<div class="instance member ">

## Two.Ellipse.width








<div class="properties">

The width of the ellipse.

</div>








<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/ellipse.js#L37)

</div>






</div>



---

<div class="instance member ">

## Two.Ellipse.height








<div class="properties">

The height of the ellipse.

</div>








<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/ellipse.js#L45)

</div>






</div>



---

<div class="instance function ">

## Two.Ellipse.clone




<div class="returns">

__Returns__:



+ `Two.Polygon`




</div>







<div class="params">

| Argument | Description |
| ---- | ----------- |
|  `parent`  | The parent group or scene to add the clone to. |
</div>




<div class="description">

Create a new instance of [Two.Polygon](/documentation/polygon) with the same properties of the current path.

</div>



<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/ellipse.js#L169)

</div>






</div>



---

<div class="instance function ">

## Two.Ellipse.toObject




<div class="returns">

__Returns__:



+ `Object`




</div>










<div class="description">

Return a JSON compatible plain object that represents the path.

</div>



<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/ellipse.js#L205)

</div>






</div>


