---
pageClass: documentation-class
---

# Two.RoundedRectangle


<div class="extends">

__Extends__: `Two.Path`

</div>





<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/rounded-rectangle.js#L10)

</div>



### Constructor


| Argument | Description |
| ---- | ----------- |
|  `x`  | The x position of the rounded rectangle. |
|  `y`  | The y position of the rounded rectangle. |
|  `width`  | The width value of the rounded rectangle. |
|  `height`  | The width value of the rounded rectangle. |
|  `radius`  | The radius value of the rounded rectangle. |
|  `resolution`  | The number of vertices used to construct the rounded rectangle. |



---

<div class="static member ">

## Two.RoundedRectangle.Properties








<div class="properties">

A list of properties that are on every [Two.RoundedRectangle](/documentation/roundedrectangle).

</div>








<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/rounded-rectangle.js#L78)

</div>






</div>



---

<div class="static member ">

## Two.RoundedRectangle.FlagRadius








<div class="properties">

A convenience function to trigger the flag for radius changing.

</div>








<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/rounded-rectangle.js#L84)

</div>






</div>



---

<div class="static function ">

## Two.RoundedRectangle.MakeObservable










<div class="params">

| Argument | Description |
| ---- | ----------- |
|  `object`  | The object to make observable. |
</div>




<div class="description">

Convenience function to apply observable qualities of a [Two.RoundedRectangle](/documentation/roundedrectangle) to any object. Handy if you'd like to extend the [Two.RoundedRectangle](/documentation/roundedrectangle) class on a custom class.

</div>



<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/rounded-rectangle.js#L92)

</div>






</div>



---

<div class="instance member ">

## Two.RoundedRectangle.width








<div class="properties">

The width of the rounded rectangle.

</div>








<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/rounded-rectangle.js#L47)

</div>






</div>



---

<div class="instance member ">

## Two.RoundedRectangle.height








<div class="properties">

The height of the rounded rectangle.

</div>








<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/rounded-rectangle.js#L55)

</div>






</div>



---

<div class="instance member ">

## Two.RoundedRectangle.radius








<div class="properties">

The size of the radius of the rounded rectangle.

</div>








<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/rounded-rectangle.js#L63)

</div>






</div>



---

<div class="instance function ">

## Two.RoundedRectangle.clone




<div class="returns">

__Returns__:



+ `Two.RoundedRectangle`




</div>







<div class="params">

| Argument | Description |
| ---- | ----------- |
|  `parent`  | The parent group or scene to add the clone to. |
</div>




<div class="description">

Create a new instance of [Two.RoundedRectangle](/documentation/roundedrectangle) with the same properties of the current path.

</div>



<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/rounded-rectangle.js#L290)

</div>






</div>



---

<div class="instance function ">

## Two.RoundedRectangle.toObject




<div class="returns">

__Returns__:



+ `Object`




</div>










<div class="description">

Return a JSON compatible plain object that represents the path.

</div>



<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/rounded-rectangle.js#L327)

</div>






</div>


