---
pageClass: documentation-class
---

# Two.Star


<div class="extends">

__Extends__: `Two.Path`

</div>





<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/star.js#L10)

</div>



### Constructor


| Argument | Description |
| ---- | ----------- |
|  `x`  | The x position of the star. |
|  `y`  | The y position of the star. |
|  `innerRadius`  | The inner radius value of the star. |
|  `outerRadius`  | The outer radius value of the star. |
|  `sides`  | The number of sides used to construct the star. |



---

<div class="static member ">

## Two.Star.Properties








<div class="properties">

A list of properties that are on every [Two.Star](/documentation/star).

</div>








<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/star.js#L74)

</div>






</div>



---

<div class="static function ">

## Two.Star.MakeObservable










<div class="params">

| Argument | Description |
| ---- | ----------- |
|  `object`  | The object to make observable. |
</div>




<div class="description">

Convenience function to apply observable qualities of a [Two.Star](/documentation/star) to any object. Handy if you'd like to extend the [Two.Star](/documentation/star) class on a custom class.

</div>



<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/star.js#L80)

</div>






</div>



---

<div class="instance member ">

## Two.Star.innerRadius








<div class="properties">

The size of the inner radius of the star.

</div>








<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/star.js#L37)

</div>






</div>



---

<div class="instance member ">

## Two.Star.outerRadius








<div class="properties">

The size of the outer radius of the star.

</div>








<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/star.js#L45)

</div>






</div>



---

<div class="instance member ">

## Two.Star.sides








<div class="properties">

The amount of sides the star has.

</div>








<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/star.js#L53)

</div>






</div>



---

<div class="instance function ">

## Two.Star.clone




<div class="returns">

__Returns__:



+ `Two.Star`




</div>







<div class="params">

| Argument | Description |
| ---- | ----------- |
|  `parent`  | The parent group or scene to add the clone to. |
</div>




<div class="description">

Create a new instance of [Two.Star](/documentation/star) with the same properties of the current path.

</div>



<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/star.js#L199)

</div>






</div>



---

<div class="instance function ">

## Two.Star.toObject




<div class="returns">

__Returns__:



+ `Object`




</div>










<div class="description">

Return a JSON compatible plain object that represents the path.

</div>



<div class="meta">

  [Source Code](https://github.com/jonobr1/two.js/blob/dev/src/shapes/star.js#L236)

</div>






</div>


